
;RHL Transparent Icons - DednDave, 4-2012

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .586
        .LIST
        INCLUDE    RhlIco.inc

;#####################################################################################

;       .DATA

;*************************************************************************************

        .DATA?

hInstance  HINSTANCE ?
hDlg       HWND ?
hBrush5    HANDLE ?

hStatic1   HWND ?
hStatic2   HWND ?
hStatic3   HWND ?
hStatic4   HWND ?
hStatic5   HWND ?

;#####################################################################################

        .CODE

;*************************************************************************************

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     eax,uMsg

        .if eax==WM_CTLCOLORSTATIC
            mov     eax,lParam                    ;wParam = hDC, lParam = control handle
            .if eax==hStatic5
                INVOKE  SetBkColor,wParam,hBrush5
                mov     eax,hBrush5               ;return hBrush5 for hStatic5
            .else
                xor     eax,eax                   ;return FALSE for other static controls
            .endif
                jmp     DlExit

        .elseif eax==WM_INITDIALOG
            push    ebx
            push    esi
            push    edi
            INVOKE  LoadIcon,hInstance,IDI_ICON
            INVOKE  PostMessage,hWnd,WM_SETICON,ICON_BIG,eax
            mov     ebx,IDC_STC1
            mov     esi,IDI_ICON1
            mov     edi,offset hStatic1
            .while ebx<IDC_STC5
                INVOKE  GetDlgItem,hWnd,ebx
                mov     [edi],eax
                INVOKE  LoadImage,hInstance,esi,IMAGE_ICON,0,0,0
                INVOKE  SendMessage,[edi],STM_SETIMAGE,IMAGE_ICON,eax
                inc     esi
                add     edi,4
                inc     ebx
            .endw
            INVOKE  GetDlgItem,hWnd,IDC_STC5 ;ebx
            mov     hStatic5,eax
            INVOKE  CreateSolidBrush,000000FFh    ;COLORREF = red
            mov     hBrush5, eax
            pop     edi
            pop     esi
            pop     ebx

        .elseif eax==WM_CLOSE
            INVOKE  DeleteObject,hBrush5
            INVOKE  EndDialog,hWnd,0

        .else
            xor     eax,eax
            jmp     DlExit

        .endif

        mov     eax,TRUE

DlExit: ret

DlgProc endp

;*************************************************************************************

_main   PROC

        xor     edi,edi                           ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     eax
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,IDW_DIALOG1,edi,DlgProc,edi
        INVOKE  ExitProcess,eax

_main   ENDP

;#####################################################################################

        END     _main

